/* Programa    complex06.c  
	Assunto:  	Imagem de uma curva por um polinômnio complexo.
	Programa 	sem erros
	
	Condição: compile com
		gcc -Wall -oprog -lm complex06.c
		
		inclua a biblioteca ambiente.h no mesmo diretório e altere
			linha de inclusão desta biblioteca

   Descrição: Determina a imagem da fronteira do quadrado 
       [-3,3]x[-3,3]  pela função exponencial.
   	Procure comentário "enfase"
         

   por Tarcisio Praciano Pereira - 10 lições para aprender C
   Sobral, Novembro de 2002 - na era Lula	- UVA

	Palavras-chave: imagem de curvas por polinômios complexos
	palavras chave: struct, estrutura
	palavras chave: fronteira de uma superficie de Riemann 	
   por Tarcisio Praciano Pereira - 10 lições para aprender C
   Sobral,  de 2008	- UeVA    	      		
*/

# include <stdio.h>  	// (1) leitura da biblioteca padrão
# include <stdlib.h>
# include <math.h>
//# include "/home/tarcisio/tex/c/ufg/ambiente.h"
# include "complexos.h"

int	menu();
int	noticia();
int	executa_opcao(int selecao, Complexo z, float raio,
          Complexo a0, Complexo a1,Complexo a2, Complexo a3);


int main(void)
{
   char	titulo[90], msg1[15], msg2[15];
   int	selecao=0;	
   int	continua = 1; // para manter o loop principal
   float raio=1; // valor default para o raio
   Complexo a0={0,0}, a1 ={0,0}, a2={1,0},  a3={0,1};
   Complexo z={3.0,4.0};
   limpa_janela();
   // **********   O loop principal do programa  ******************
   while(continua)
   {
   printf("Deseja ver as informações sobre programa, a resposta padrão é não\n");
   if( sim_nao() ) noticia();
   selecao = menu(); // 1  2 3  4  5  6
      printf("selecao = %d", selecao); apeteco2();          // *** aqui **** apagar
   switch(selecao)
   {
     case 1:
       strcpy(titulo,"Imagem de circulo por exp ");
       break;
     case 2:
       strcpy(titulo,"Imagem de circulo por pol. do segundo grau ");
       break;//régua  01234567890123456789012345678901234567890
     case 3:
       strcpy(titulo,"Imagem de circulo por pol. do terceiro grau ");
       break;
     case 4:
       strcpy(titulo,"Imagem de um retangulo por exp ");
       break;       
     case 5:
       strcpy(titulo,"Imagem de retangulo por pol do seg grau ");
       break;
     case 6:
       strcpy(titulo,"Imagem de retangulo por pol do ter. grau ");
       break;
   } // fim do switch - construção parcial da mensagem - title p gnuplot
   limpa_janela();
   printf("O ponto central da curva  z = a + bi \n");
   z.a = entrada_float(" a =  ", z.a);
   z.b = entrada_float(" b =  ", z.b);   
   sprintf(msg1, "%2.2f", z.a); sprintf(msg2, "%2.2f", z.b);  // (50) 
   strcat(titulo," centro ("); strcat(titulo,msg1);strcat(titulo,",");
   strcat(titulo,msg2); strcat(titulo,")");
   printf("Eu aceito um coeficiente de dilatação, o raio, o valor padrão é 1 \n");
   raio = entrada_float(" raio   rho = ", raio);
   strcat(titulo," raio= "); sprintf(msg1, "%2.2f", raio); strcat(titulo,msg1);
      printf("selecao = %d", selecao); apeteco2();          // *** aqui **** apagar
   executa_opcao(selecao, z, raio, a0,  a1,  a2, a3);
	prepara_gnuplot(titulo);
	system("gnuplot -persist transfere");
	printf("Deseja fazer novo gráfico ?  a resposta padrão é não \n");
	if ( sim_nao())  continua = 1; else continua = 0;
	} 
	// **********  fim do loop principal  do programa  ************
	printf("Deseja ver os direitos autorais ? - a resposta padrão é não \n");
	if( sim_nao() ) copyleft();
	apetecof(); limpa_janela();
	return 0;
}

int noticia()
{
   limpa_janela();
	printf("	===== Imagens de algumas curvas por funções complexas ========= \n");
	printf("   Uma rápida explicação sobre as possiblidades\n");
	printf("   do programa antes que você faça sua seleção:  \n" );
	printf("Este programa sabe calcular a imagem de um círculo ou de um \n");
	printf("retângulo  por uma das seguintes funções complexas: \n");
	printf("\ta exponencial, um polinômmio do segundo grau,  \n");
	printf("\tum polinômio do terceiro grau. \n");
	printf("O programa vai percorrer a curva escolhida e calcular a imagem\n");
	printf("da curva-imagem (pela função complexa que você escolher) e passar\n");
	printf("os dados para gnuplot fazer o gráfico. \n");
	printf("Você poderá fazer uma seleção entre as possíveis combinações, \n");
	printf("a expondencial complexa ou dos polinômios e depois a imagem \n");
	printf("pela função escolhida, do   círculo  ou do retângulo. \n");
	printf("O programa vai lhe oferecer estas opções. \n");	
   apeteco2();
   printf("\t O programa aceita um ponto onde a curva vai ficar centrada e o\n");
   printf("raio - um coeficiente de dilatação. \n");
   printf("O valor padrão para o coeficiente de dilatação (raio) é 1. \n");
   printf("\t A escolha de um valor diferente de 1 para o raio vai lhe permitir\n"); 
   printf("ver a transformação de curvas com diferentes tamanhos no plano complexo, \n");
   printf("grandes curvas ou pequenas curvas. Experimente com um valor grande para\n");
   printf("o raio, use a exponencial sobre um círculo de centro na origem, é um\n");
   printf("bonito gráfico que você vai obter. Gnuplot lhe permite dar zooms na ima-\n");
   printf("gem e você pode ver o que acontece na vizinhança de um ponto. Estude também\n");
   printf("a equação da curva imagem para entender o que está acontecendo. \n");
   printf("\t O programa tem valores padrão que você pode aceitar acionando o \n");
   printf("enter  quando for perguntado. Esta é uma boa opção, inicialmente, para ver\n");
   printf("como o programa funciona.\n");
   apeteco2();	
   printf("Este programa cria dois arquivos, no mesmo diretório em que estiver operando,\n");
   printf("	\t  \"dados\" e \"transfere\".  \n");
   printf("No arquivo \"dados\" se encontram os pares de pontos - a matriz de pontos\n");
   printf("que gnuplot vai usar para apresentar a curva. \n");
   printf("No arquivo \"transfere\" estão os comandos do gnuplot que voce pode alterar\n");
   printf("para incluir novas opções para o gráfico. \n");
   printf("	Se você apenas desejar ver, novamente, o gráfico, rode: \n");
	printf("\t gnuplot  transfere \n" );
	printf("num terminal, no mesmo diretório em que estiver rodando o programa.\n");
	printf("\t Você pode editar o arquivo transfere para colocar outros comandos\n");
	printf("do gnuplot, por exemplo para produzir um arquivo num formato que \n");
	printf("seja mais conveniente:  png, jpeg, ....  \n");
	apeteco2(); 
	printf("\t Finalmente, uma melhoria neste versão do programa, ele fica no ar \n");
	printf("enquanto você quiser fazer curvas. Você pode usar o \"print screen\" do \n");
	printf("do teclado para bater uma foto das curvas e assim comparar algumas delas.\n");
	printf("Você também pode trocar o nome do arquivo \"dados\", por exemplo: \n");
	printf("\t dados1, dados2, dados3 .....\n");
	printf("e depois editar o arquivo \n");
	printf("\t \"transfere\" \n");
	printf("para ver múltiplos gráficos de curvas. \n");
	printf("\t Ou então, altere o programa... \n");
   apeteco2();limpa_janela();	 
	return(0);
}

int	menu()
{
  int	selecao=1;
  char opcao='d'; // (30) começando errado senão nãp entra no while
  printf("Este programa sabe calcular a imagem sobre dois tipos de curva, \n");
  printf("a imagem da fronteira de uma retângulo ou de um círculo centrados  \n");
  printf("num ponto que você pode escolher. \n");
  opcao = 'd'; // (30) opção errada para entrar no while
  while( (opcao !='c')*(opcao !='C')*(opcao !='r')*(opcao !='R') )
  {
    printf("Faça a sua seleção: \n\n\n");
    printf(" c -  imagem da fronteira de um círculo   --> <c>   \n");
    printf(" r -  imagem da fronteira de um retângulo --> <r> \n\n\n");
    opcao	= entrada_caracter(" <c , r> ? --> ", opcao);
    // (10) porque a opção 'c' é a opção zero.... e 'r' é opção  3
    if ( (opcao == 'c')+(opcao == 'C') ) selecao = 0; 
          else selecao = 3; //  1,2,3, p/ circulo, 4,5,6 p/ retângulo
  }
  limpa_janela();
  printf("O programa conhece três funções: \n");
  printf("a exponencial (complexa) \t\t< e >  \n");
  printf("um polinômio do segundo grau \t\t< s >  \n");
  printf("um polinômio do terceiro grau \t\t< t >  \n");
  opcao = 'd';  // opcao errada, para entrar no while()
  while( (opcao !='e')*(opcao !='E')*(opcao !='s')*(opcao !='S')*(opcao !='t')*(opcao !='T'))
  {
  printf("Faça a sua seleção: \n");  
  printf(" <e>-xponencial -------------------> < e >  \n");
  printf(" Polinômio so <s>-egundo grau -----> < s >  \n");
  printf(" Polinômio so <t>-erceiro  grau ---> < t > \n");  
  opcao	= entrada_caracter(" < e , s , t >  --> ", opcao);  
  }
  // (20) o resultado vai ser 1,2,3   ou   4, 5, 6  dependo de selecao
  if ( (opcao == 'e')+(opcao == 'E') ) selecao = selecao + 1; 
          else 
          if ( (opcao == 's')+(opcao == 'S') ) selecao = selecao + 2;
          else selecao = selecao + 3;  //  1,2,3,4,5,6 exp, segundo , terceiro  
  return(selecao);  // 1 2 3 4 5 6 uma dessas opções apenas
}

int	executa_opcao(int selecao, Complexo z, float raio,
          Complexo a0, Complexo a1,Complexo a2, Complexo a3)
{
  switch(selecao)
  {
    case 1:
      curva_circulo(selecao, z, raio, a0,  a1,  a2, a3);
      break;
        
    case 2:
      curva_circulo(selecao, z, raio, a0,  a1,  a2, a3);     
      break;    
    case 3:
      curva_circulo(selecao, z, raio, a0,  a1,  a2, a3);
      break;    
    case 4:
      curva_retangulo(selecao, z, raio, a0,  a1,  a2, a3);
      break;    
    case 5:
      curva_retangulo(selecao, z, raio, a0,  a1,  a2, a3);
      break;    
    case 6:
      curva_retangulo(selecao, z, raio, a0,  a1,  a2, a3);
      break;    
  }    
return(0);
}

/* Comentários:  A numeração dos comentários não
		  é continuada, pode dar saltos...para
		  facilitar a reutilização de programas.

(10) Um troque lógico!  se for escolhido 'c'  ou 'C' vair dar uma soma
    diferente dezero que representa verdade então  selecao vai receber
    0  que é a opção para círculo.
    
    As opções são 1,2,3  -  círculo com uma das funções ou
                  4,5,6  -  retângulo com uma das funções
    
(20) Como seleção é 0  ou  3  na primeira escolha, então, agora, com
    esta soma vou ter  1,2,3  (caso selecao = 0) ou 
                       4,5,6  (caso selecao = 3) 

(30) O while() que controla a entrada correta, somente roda se houver
    uma opção errada, então iniciei com opcao = 'd' que é errada para
    rode pelo menos uma vez o while()

(50) sprintf()  permite conversão float --> string e outras também
    
*/


